/****************************************************************************
 File name:  fileIO.c
 Author:     $Author: chadd $
 Date:       Sep 13, 2011
 Class:      CS300
 Assignment: In Class Example
 Purpose:    Demonstrate how to use fopen/fclose/fgetc/perror
 RevisionID:  $Id: fileIO.c 40 2011-09-13 17:34:45Z chadd $
 ****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

/****************************************************************************
 Function:    main
 Description: demonstrates file IO and the use of errno
 Parameters:  None
 Returned:    None
 ****************************************************************************/

int main()
{
	/* open a file in read only mode */
	FILE * fPtr = fopen("data/file.txt", "r");

	char letter;

	/* if the file pointer is NULL, an error occured */
	if( NULL == fPtr)
	{
		/* perror will display the most recent error and the string
		 * given as an argument
		 */
		perror("File did not open");
		return -1;
	}

	/* fgetc gets a single character */
	letter = fgetc(fPtr);

	/* if EOF is returned, the End Of File has been reached */
	if( EOF != letter)
	{
		printf("%c", letter);
	}

	/* close the file */
	fclose(fPtr);

	return EXIT_SUCCESS;
}
